// MyWin.cpp : implementation file
//

#include "stdafx.h"
#include "float.h"
#include "MyWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyWin

CMyWin::CMyWin(CWnd* pW):COGLWnd(pW)
{
	// Window is created and we can 
	// set up the drawing environment

	SetUpDrawingEnvironment();
	ASSERT(m_hRC !=NULL);

	// do one-time initializing
	InitializeRContext();

	// set mousing around variables
	m_Vx=m_Vy=0.0f;
	m_dvy=m_dvx=0.0f;
	m_MovementInProgress=FALSE;
	
}

CMyWin::~CMyWin()
{
}


BEGIN_MESSAGE_MAP(CMyWin, COGLWnd)
	//{{AFX_MSG_MAP(CMyWin)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyWin message handlers
void CMyWin::DrawScene()
{
	// calc the viewing box according to
	// the scene you want to see
	GLfloat dx=1.5f;
	GLfloat dy=1.5f;
	// set the view
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	glOrtho(-dx,dx,-dy,dy,0.0f,100.0f);
	glMatrixMode(GL_MODELVIEW);

	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// looking down negative z
	glTranslatef(0.0f,0.0f,-5.0f);

	// display the backgound bitmap
	if((m_OGLIMAGE.GetWidth()>4)&&(m_OGLIMAGE.GetHeight()>4))
	{
		glRasterPos3f(-dx,-dy,-50.0f);
		glPushMatrix();
		glDrawPixels(
			m_OGLIMAGE.GetWidth(), 	
			m_OGLIMAGE.GetHeight(), 	
			GL_RGB,
			GL_UNSIGNED_BYTE,
			m_OGLIMAGE.GetBitsPtr() 	
			);
		glPopMatrix();
	}

	m_Vy=m_Vy+m_dvy;
	m_Vx=m_Vx+m_dvx;


	// tilt it around x
	glRotatef(m_Vx,1.0f,0.0f,0.0f);
	// tilt it around y
	glRotatef(m_Vy,0.0f,1.0f,0.0f);

	CMaterial::SetMaterial(BRONZE);
	m_Logo.DrawLogo();

	
	// finnish drawing
	glFlush();
}

void CMyWin::InitializeRContext()
{
	// Replace this call with your own one-time 
	// initialization code
	COGLWnd::InitializeRContext();
    // (re)set background to white
	glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
}

void CMyWin::OnSize(UINT nType, int cx, int cy) 
{
	glViewport(0, 0, cx, cy);
	CWnd::OnSize(nType, cx, cy);

}

void CMyWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed left button.Make a note
	// of this and prepare for intuitive rotation of scene
	m_PLast=point;
	SetCapture();
	m_dvy=m_dvx=0.0f;
	CWnd::OnLButtonDown(nFlags, point);
}

void CMyWin::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and terminate rotation
	ReleaseCapture();
	if(m_MovementInProgress)
	{
		// continue rotation
		MSG msg;
		do
		{
			m_Vy+=m_dvy;
			m_Vx+=m_dvx;
			RedrawWindow();
		}while (!PeekMessage(&msg,GetSafeHwnd(),
					WM_LBUTTONDOWN,WM_RBUTTONDOWN,
					PM_NOREMOVE));
	}
	m_MovementInProgress=FALSE;
	//m_dvy=m_dvx=0.0f;

	CWnd::OnLButtonUp(nFlags, point);
}

void CMyWin::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down and this is not a result of
	// a stop-click
	if(nFlags & MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>1)||(abs(m_PLast.y-point.y)>1))
		{
			// then we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);

			m_dvy=60.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_dvx=60.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			
			m_Vy=m_Vy+m_dvy;
			m_Vx=m_Vx+m_dvx;
			
			// rememeber point and force immediate redraw 
			m_PLast=point;
			RedrawWindow();
			m_MovementInProgress=TRUE;
		}
		else
			m_MovementInProgress=FALSE;
	}
}
